;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;
;      2000 
;        
; ,    "  "
; !    !
; ,   - .
;
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;
     List P=PIC18F452
	#include      <p18f452.inc>
;Program Configuration Register 1H
  __CONFIG _CONFIG1H, _HS_OSC_1H 

;Program Configuration Register 2L
  __CONFIG _CONFIG2L, _BOR_OFF_2L & _PWRT_ON_2L

;Program Configuration Register 2H
  __CONFIG _CONFIG2H, _WDT_OFF_2H 

;Program Configuration Register 3H
  __CONFIG _CONFIG3H, _CCP2MX_ON_3H

;Program Configuration Register 4L
  __CONFIG _CONFIG4L, _STVR_OFF_4L & _LVP_OFF_4L & _DEBUG_OFF_4L

;Program Configuration Register 5L
  __CONFIG _CONFIG5L, _CP0_OFF_5L & _CP1_OFF_5L & _CP2_OFF_5L & _CP3_OFF_5L 

;Program Configuration Register 5H
  __CONFIG _CONFIG5H, _CPB_OFF_5H & _CPD_OFF_5H

;Program Configuration Register 6L
  __CONFIG _CONFIG6L, _WRT0_OFF_6L & _WRT1_OFF_6L & _WRT2_OFF_6L & _WRT3_OFF_6L 

;Program Configuration Register 6H
  __CONFIG _CONFIG6H, _WRTC_OFF_6H & _WRTB_OFF_6H & _WRTD_OFF_6H

;Program Configuration Register 7L
  __CONFIG _CONFIG7L, _EBTR0_OFF_7L & _EBTR1_OFF_7L & _EBTR2_OFF_7L & _EBTR3_OFF_7L

;Program Configuration Register 7H
  __CONFIG _CONFIG7H, _EBTRB_OFF_7H


;************************************************************
;    ( )
;
;                                      PORTE <2:0> 
;                                                   ( )	
;	0               CH8                                             000	
;	1               CH5                                             001
;	2               CH7                                             010
;	3               CH6                                             011
;	4                                                   100			
;	5                                              101
;	6                                           110
;	7                                                             111
;	8                                    000
;	9                               001
;	10                          010
;	11                                           011
;	12          EXTRIM4         100
;	13          EXTRIM1         101
;	14          EXTRIM2         110
;	15          EXTRIM3         111
;	16             Vpos monitor                              000
;	17              (EXTRIM5)                    001
;	18              (EXTRIM6)                    010
;	19              (EXTRIM7)                    011
;	20              (EXTRIM8)                    100
;	21              (EXTRIM9)                    101
;	22              (EXTRIM10)                  110
;	23              (EXTRIM11)                  111
;************************************************************




;************************************************************
;      ( )
;
;                                      PORTE <2:0> 
;                                                   ( )	
;	0                                                           000	
;	1                                           001
;	2                                           010
;	3                             011
;	4                                                100			
;	5                                  101
;	6                                        110
;	7                          111
;	8                         CH8                                000
;	9                         CH5                                001
;	10                       CH7                                010
;	11                       CH6                                011
;	12          EXTRIM4         100
;	13          EXTRIM1         101
;	14          EXTRIM2         110
;	15          EXTRIM3         111
;	16             Vpos monitor                              000
;	17              (EXTRIM5)                    001
;	18              (EXTRIM6)                    010
;	19              (EXTRIM7)                    011
;	20              (EXTRIM8)                    100
;	21              (EXTRIM9)                    101
;	22              (EXTRIM10)                  110
;	23              (EXTRIM11)                  111
;************************************************************
;     

;  PortA 
; RA0,RA1,RA3-  
; RA2,RA4,RA5-  LCD
 
; PORTD-  LCD

;  PORTC
; RC0 -   
BUZZER 	EQU	0; 
; RC1 -  !!!!!
; RC2 - LED1( OVERRUN)
LED1  EQU  2 ;   OVERRUN
; RC3 -  SPI
; RC4 -  SPI (SDI)
; RC5 -  SPI (SDO)
; RC6 - 
; RC7 -
;
;  PORTB
; RB0 -   4 (RUNCAL,AUTOT,OPTION,PRESET,
; ALTAFK,SNAPR,SNAPL)
; RB1 -   5 (SWA,SWB,SWC,SWD,
; SWE,SWF,SWG,SWH)
; RB2 -  0   
; RB3 -     (CS)
; RB4 -  1    

; RB5 -  2   
; RB6 -       
;          
; RB7 - -     
;          
;
;  PORTB1 -   
;SWA	EQU	0
;SWB	EQU	1
;SWC	EQU	2
;SWD	EQU	3
;SWE	EQU	4
;SWF	EQU	5
;SWG	EQU	6
;SWH	EQU	7
;
;  0-3 PORTB0 -     
;     4.    
;        . . 
;    
RUNCAL     EQU     0 ;  RUNCAL 0=CAL ; 1=RUN
AUTOT	      EQU	1
OPTION	EQU	2
PRESET	EQU	3
;   4 - 7  
;SW8  A	EQU	4
;SW8  C	EQU	5
;SWK	      EQU	6
;SWI	      EQU	7
;
;  PORTE
;  0-2 -  
;
;**** 	
;
TICKSPER EQU  D'40' ;     
CYCLECOUNTS EQU (D'2000000'/TICKSPER);  
;                         25 mS   F=8
modeRUN  EQU  1 ;   RUN
modeCAL  EQU  2 ;   CAL
 
;*******  BANK0 
;  
   CBLOCK  H'00';  !!!!      !!!!!
;*******   
   TEMP_W;    W !!!   !!!	
   TEMP_STATUS     
   TEMP_PCLATH
   TEMP_PCLATU
   TEMP_BSR     
;******* 
   Areg		;   
   Breg		;   
   Pstate;     RC1 
;  Pstate   -
;     .
;  Pstate  -  
;
   TimeCount  ;  
   TimeCount1  ;  
   TimeCount100  ;  
   DataTemp ;  LCDsendData
   DataCheck ;  BUSY_CHECK   
;
;  /   
   TEMP
   TEMPB0
   TEMPB1
   TEMPB3   
   AARGB0
   AARGB1
   AARGB2
   AARGB3
   BARGB0
   BARGB1		
   REMB0
   REMB1
   FPFLAGS
   SIGN
   LOOPCOUNT
 ;
   LINLOG1;  .  exp RATE()
   REVERS1;   
   SpromNo;     
;  SpromNo=FF -   !!!!  SpromNo=0 -   !!!
        ENDC

   CBLOCK
;      
   Cmode;  , 0 -  , 1 -  
   Tick	; 
   Dsecs      ;     
   Dmins      ;     
   DsecsLatch ;      
   Secs       ;  
   Mins       ;  
   BeepTicks  ;    25  .
       ; / RTC      .
;     
   BeepCtr	;  
   BeepCyl;      
;  .    .
   TimeOut;  -    USART. RT   
          ;      .   / RS232
   TimeOut1 ;  USART.   / RS232  
   TimeOut2 ; AutoTrimTime  
   TimeOut3 ; =1 -      
   TimeOut4 ; =10        RUN   
   TimeOut5 ; =80     
            ; . / ButtonID  
 
  ;   PORTB0
   PORTB0  
   PORTBimage0  
   PORTBlast0  
   PORTBlatch0
  ;  PORTB1
   PORTB1
   PORTBimage1  
   PORTBlast1  
   PORTBlatch1  
   Mode	 ;    
   CHtimes;    
     ;  ISR     !!!!!!

   ENDC 

;     
;  16-     
chAIL	EQU	CHtimes+2      ; 2 
chELE	EQU	CHtimes+4      ; 2 
chRUD	EQU	CHtimes+6      ; 2 
chTHT	EQU	CHtimes+8      ; 2 
chCH5	EQU	CHtimes+D'10'  ; 2 
chCH6	EQU	CHtimes+D'12'  ; 2 
chCH7	EQU	CHtimes+D'14'  ; 2 
chCH8	EQU	CHtimes+D'16'  ; 2 
;
;  
;    
AXreg	EQU	chCH8+D'2'; 2 
BXreg   EQU     AXreg+D'2'; 2 
CXreg	EQU	BXreg+D'2'; 2 
DXreg	EQU     CXreg+D'2'; 2 
EXreg	EQU     DXreg+D'2'; 4 
Atemp	EQU	EXreg+D'4'
Btemp	EQU	Atemp+D'1'
Ctemp   EQU	Atemp+D'2'
Dtemp   EQU	Atemp+D'3'
Etemp   EQU	Atemp+D'4'
Ftemp   EQU	Atemp+D'5'
;
Pos EQU Ftemp+1 ; 2   
Npos EQU Pos+2 ; 2   
;
;        
;    -1024  +1024     
;  o 0 o 1023
Apos	EQU	Npos+D'2'  ; 2   
Epos	EQU	Apos+D'2'  ; 2  
Rpos	EQU	Apos+D'4'  ; 2  
Tpos	EQU	Apos+D'6'  ; 2  
Tmax	EQU	Tpos+D'2'; 2 !!  
	;      RATE
CH5pos	EQU	Tmax+D'2'   ; 2  
CH6pos	EQU	CH5pos+D'2' ; 2  
CH7pos	EQU	CH6pos+D'2' ; 2  
CH8pos	EQU	CH7pos+D'2' ; 2  
Atrim    EQU	CH8pos+2     ; 2 
Etrim	 EQU	Atrim+D'2'   ; 2  
Rtrim	 EQU	Atrim+D'4'   ; 2  
Ttrim	 EQU	Atrim+D'6'   ; 2 
;      !!!!
EXTRIM1	 EQU	Ttrim+D'2'   ; 1  
EXTRIM2	 EQU	EXTRIM1+1  ; 1   
EXTRIM3	 EQU	EXTRIM2+1  ; 1  
EXTRIM4	 EQU	EXTRIM3+1  ; 1  
; 
;   
AposM		EQU	EXTRIM4+1; 2  
EposM		EQU	AposM+D'2'   ; 2  
RposM		EQU	AposM+D'4'   ; 2  
TposM		EQU	AposM+D'6'   ; 2  
CH5posM	EQU	AposM+D'8'   ; 2  
CH6posM	EQU	AposM+D'10'  ; 2  
CH7posM	EQU	AposM+D'12'  ; 2  
CH8posM	EQU	AposM+D'14'  ; 2 !!
;
;  
Vbat   EQU CH8posM+2; 2    
Dst EQU	Vbat+2; 2  .  
Src EQU	Dst+2; 2  .  
Cnt EQU	Src+2;    
;
OVERRUN	EQU     Cnt+1  ;    
;        
SymSet	EQU OVERRUN+1;   
;     
;       .
SWID	EQU     SymSet+1; 2 - 
;      
EXIT    EQU     SWID+2; -   
;
;  11     
;   .
; !!!!   !!!!!!
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
CalTable	      EQU     EXIT+1
EXPOtable0	EQU     CalTable+1

EXPOtable1	EQU     EXPOtable0+1
EXPOtable2	EQU     EXPOtable1+1
EXPOtable3	EQU     EXPOtable2+1
EXPOtable4	EQU     EXPOtable3+1
EXPOtable5	EQU     EXPOtable4+1
EXPOtable6	EQU     EXPOtable5+1
EXPOtable7	EQU     EXPOtable6+1
;  2     
;    !!!!   !!!!!!
EXPOtable8	EQU     EXPOtable7+1
EXPOtable9	EQU     EXPOtable8+1
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SWselect	EQU     EXPOtable9+1
;
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!!  7   ..  !! 
EXPP	EQU     SWselect+1;  
RTUP	EQU     EXPP+1 ; / 
CENTER	EQU     RTUP+1;  
LTDWN	EQU     RTUP+2; / 
DRP	EQU     RTUP+3;  DR
ATRM	EQU     RTUP+4;  Autotrim 
TRIMP	EQU     RTUP+5;  
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

ATRST	EQU     TRIMP+1;   Autotrim 
YESNO	EQU     ATRST+1
;
NextTime  EQU YESNO+1 ; 2   
	   ;    TMR1
Psum  EQU YESNO+3 ; 2   
      ;      
Sync  EQU YESNO+5 ; 2  
 
;  , ( ADC )* VmonG = millivolts
VmonG	EQU	Sync+D'2'; 2   
rxdata	EQU VmonG+D'2'
;  
;   
;
; !!!!  7  !!!!
;     
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
Mfrom	  EQU     rxdata+D'1'
Mto	        EQU     Mfrom+1
Mzp	  EQU     Mto+1
Mpg	  EQU     Mzp+1
Mng	  EQU     Mpg+1
TrimZP   EQU     Mng+1
TrimRU  EQU     TrimZP+1
TrimLD  EQU     TrimRU+1
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
Mpi            EQU     TrimLD+1
Mni	           EQU     Mpi+1
Mreplace  EQU     Mni+1
Mtbl	     EQU     Mreplace+1
Mtrim	     EQU     Mtbl+1;  
;
;  SNAP
SR_Ae	  EQU     Mtrim+D'1'
SR_Ee	  EQU     SR_Ae+1
SR_Re	  EQU     SR_Ee+1
SR_Te	  EQU     SR_Re+1
SL_Ae	  EQU     SR_Te+1
SL_Ee	  EQU     SL_Ae+1
SL_Re	  EQU     SL_Ee+1
SL_Te 	  EQU     SL_Re+1
;
SelFreq   EQU     SL_Te+D'1';   
;                           ; =FF- 
MinByte	  EQU	  SelFreq+1
MaxByte	  EQU     MinByte+1
TRIMselect	  EQU     MaxByte+1


;MinTime	EQU	TRIMselect	+1  ;  2
;MaxTime	EQU	MinTime+2  ;  2!!!!!
;
;
;   BANK1
; 
;      
;  .  EEPROM  
; 32   .   
;      . 
;    ..  !!!!!!!
;  
   CBLOCK H'100'
   Aircraft	;    1  32
   ENDC

Name EQU Aircraft+1; 16     !!!
;
REVERS  EQU  Name+D'16' ;    
			;   
LINLOG  EQU  REVERS+1   ;    
			;   
; 
AEXP	EQU  LINLOG+1 ; EXP  
AMRT	EQU  AEXP+1   ;    
Acentr	EQU  AEXP+2   ;    
AMLT	EQU  AEXP+3   ;    
ALR     EQU  AEXP+4   ;  dual rate  
AAT     EQU  AEXP+5   ;  Autotrim -   !!!
APT     EQU  AEXP+6   ;   
;
;  
EEXP	EQU  APT+1    ; EXP  
EMUP	EQU  EEXP+1   ;    
Ecentr	EQU  EEXP+2   ;    
EMDWN	EQU  EEXP+3   ;    
ELR     EQU  EEXP+4   ;  dual rate  
EAT     EQU  EEXP+5   ;  Autotrim -   !!!
EPT     EQU  EEXP+6   ;   
;
;  
REXP	EQU  EPT+1    ; EXP  
RMRT	EQU  REXP+1   ;    
Rcentr	EQU  REXP+2   ;    
RMLT	EQU  REXP+3   ;    
RLR     EQU  REXP+4   ;  dual rate  
RAT     EQU  REXP+5   ;  Autotrim -   !!!
RPT     EQU  REXP+6   ;   
;
; 
TEXP	EQU  RPT+1    ; EXP  
TMUP	EQU  TEXP+1   ;    
Tcentr	EQU  TEXP+2   ;    
TMDWN	EQU  TEXP+3   ;    
TLR   	EQU  TEXP+4   ;  -   !!!
TMODE   EQU  TEXP+5   ;  :
                                    ;0-   
                                    ;1-     
                                    ;2-     
TPT     EQU  TEXP+6   ;   
;
; CH5     ????  ????
CH5EXP	 EQU  TPT+1   ; EXP  
CH5MRTUP EQU  CH5EXP+1;    
CH5centr EQU  CH5EXP+2;    
CH5MLTDWN EQU  CH5EXP+3;    
CH5LR    EQU  CH5EXP+4;  -   !!!
;
; CH6
CH6EXP	 EQU  CH5LR+1 ; EXP  
CH6MRTUP EQU  CH6EXP+1;    
CH6centr EQU  CH6EXP+2;    
CH6MLTDWN EQU  CH6EXP+3;    
CH6LR    EQU  CH6EXP+4;  -   !!!
;
; CH7
CH7EXP	 EQU  CH6LR+1 ; EXP  
CH7MRTUP EQU  CH7EXP+1;    
CH7centr EQU  CH7EXP+2;    
CH7MLTDWN EQU  CH7EXP+3;    
CH7LR    EQU  CH7EXP+4;  -   !!!
;
; CH8 
CH8EXP	 EQU  CH7LR+1 ; EXP  
CH8MRTUP EQU  CH8EXP+1;    
CH8centr EQU  CH8EXP+2;    
CH8MLTDWN EQU  CH8EXP+3;    
CH8LR    EQU  CH8EXP+4;  -   !!!
;
;  .
VTAIL	  EQU	CH8LR+1 ; 0=off and FF=on
ELEVON	  EQU	VTAIL+1	; 0=off and FF=on
DUALA	  EQU	VTAIL+2	; 0=off and FF=on
REVA  EQU VTAIL+3	; 0=nornal, FF= 7 
DIFFA EQU VTAIL+4 ;    
   ;     differential, 0 = off
FPgain EQU VTAIL+5 ;    (CH7) 
                 ;  , 0 = off
DefaultAircraft EQU FPgain+D'1';    
; !!!!!   ..     !!!!!
ALTaircraft EQU DefaultAircraft+1
;   . 
;    FF,   ,   
; ,    -ALTAFT -> ON
FixedFirst  EQU	ALTaircraft+1;    
;  (FF)    				
;     .
;	 
;  - 
; 1- 
M1Afrom	  EQU	FixedFirst+1
M1Ato	  EQU	M1Afrom+1
M1Azp	  EQU	M1Afrom+2
M1Aur	  EQU	M1Afrom+3
M1Adl	  EQU	M1Afrom+4
M1AtrimZP	  EQU	M1Afrom+5
M1AtrimRU  EQU	M1Afrom+6
M1AtrimLD  EQU	M1Afrom+7

M1Bfrom	  EQU	M1Afrom+8
M1Bto	  EQU	M1Bfrom+1
M1Bzp     EQU	M1Bto+1
M1Bur	  EQU	M1Bzp+1
M1Bdl	  EQU	M1Bur+1
M1BtrimZP	  EQU	M1Bfrom+5
M1BtrimRU  EQU	M1Bfrom+6
M1BtrimLD  EQU	M1Bfrom+7

M1Cfrom	  EQU	M1Bfrom+D'8'
M1Cto	  EQU	M1Cfrom+1
M1Czp	  EQU	M1Cto+1
M1Cur	  EQU	M1Czp+1
M1Cdl	  EQU	M1Cur+1
M1CtrimZP	  EQU	M1Cfrom+5
M1CtrimRU  EQU	M1Cfrom+6
M1CtrimLD  EQU	M1Cfrom+7

;M1Dfrom	  EQU	M1Cfrom+D'8'
;M1Dto	  EQU	M1Dfrom+1
;M1Dzp	  EQU	M1Dto+1
;M1Dur	  EQU	M1Dzp+1
;M1Ddl	  EQU	M1Dur+1
;M1DtrimZP	  EQU	M1Dfrom+5
;M1DtrimRU  EQU	M1Dfrom+6
;M1DtrimLD  EQU	M1Dfrom+7

; 2- 
M2Afrom	  EQU	M1Cfrom+D'8'
M2Ato	  EQU	M2Afrom+1
M2Azp	  EQU	M2Ato+1
M2Aur	  EQU	M2Azp+1
M2Adl	  EQU	M2Aur+1
M2AtrimZP	  EQU	M2Afrom+5
M2AtrimRU  EQU	M2Afrom+6
M2AtrimLD  EQU	M2Afrom+7

M2Bfrom	  EQU	M2Afrom+D'8'
M2Bto	  EQU	M2Bfrom+1
M2Bzp	  EQU	M2Bto+1
M2Bur	  EQU	M2Bzp+1
M2Bdl	  EQU	M2Bur+1
M2BtrimZP	  EQU	M2Bfrom+5
M2BtrimRU  EQU	M2Bfrom+6
M2BtrimLD  EQU	M2Bfrom+7

M2Cfrom	  EQU	M2Bfrom+D'8'
M2Cto	  EQU	M2Cfrom+1
M2Czp	  EQU	M2Cto+1
M2Cur	  EQU	M2Czp+1
M2Cdl	  EQU	M2Cur+1
M2CtrimZP	  EQU	M2Cfrom+5
M2CtrimRU  EQU	M2Cfrom+6
M2CtrimLD  EQU	M2Cfrom+7

;M2Dfrom	  EQU	M2Cfrom+D'8'
;M2Dto	  EQU	M2Dfrom+1
;M2Dzp	  EQU	M2Dto+1
;M2Dur	  EQU	M2Dzp+1
;M2Ddl	  EQU	M2Dur+1
;M2DtrimZP	  EQU	M2Dfrom+5
;M2DtrimRU  EQU	M2Dfrom+6
;M2DtrimLD  EQU	M2Dfrom+7

; 3- 
M3Afrom	  EQU	M2Cfrom+D'8'
M3Ato	  EQU	M3Afrom+1
M3Azp	  EQU	M3Ato+1
M3Aur	  EQU	M3Azp+1
M3Adl	  EQU	M3Aur+1
M3AtrimZP	  EQU	M3Afrom+5
M3AtrimRU  EQU	M3Afrom+6
M3AtrimLD  EQU	M3Afrom+7

M3Bfrom	  EQU	M3Afrom+D'8'
M3Bto	  EQU	M3Bfrom+1
M3Bzp	  EQU	M3Bto+1
M3Bur	  EQU	M3Bzp+1
M3Bdl	  EQU	M3Bur+1
M3BtrimZP	  EQU	M3Bfrom+5
M3BtrimRU  EQU	M3Bfrom+6
M3BtrimLD  EQU	M3Bfrom+7

M3Cfrom	  EQU	M3Bfrom+D'8'
M3Cto	  EQU	M3Cfrom+1
M3Czp	  EQU	M3Cto+1
M3Cur	  EQU	M3Czp+1
M3Cdl	  EQU	M3Cur+1
M3CtrimZP	  EQU	M3Cfrom+5
M3CtrimRU  EQU	M3Cfrom+6
M3CtrimLD  EQU	M3Cfrom+7

;M3Dfrom	  EQU	M3Cfrom+D'8'
;M3Dto	  EQU	M3Dfrom+1
;M3Dzp	  EQU	M3Dto+1
;M3Dur	  EQU	M3Dzp+1
;M3Ddl	  EQU	M3Dur+1
;
;     "" .
;     . 
;
TrimZeroAil   EQU	M3Cfrom+8  ; 2  
TrimZeroEle  EQU	TrimZeroAil+2  ; 2  
TrimZeroRud EQU	TrimZeroAil+4  ; 2 
TrimZeroTht  EQU	TrimZeroRud+2  ; 2 
; 
;  
;  7  -  
;  ,    
;  =1 ->    
;   -   %
SR_A	EQU     TrimZeroTht+D'2'; 2 
SR_E	EQU     SR_A+D'2'    ; 2 
SR_R	EQU     SR_A+D'4'    ; 2 
SR_T	EQU     SR_A+D'6'    ; 2 
;  
SL_A	EQU     SR_A+D'8'    ; 2 
SL_E	EQU     SR_A+D'10'   ; 2 
SL_R	EQU     SR_A+D'12'   ; 2 
SL_T	EQU     SR_A+D'14'   ; 2 !!
Tpreset   EQU  	SR_A+D'16'   ;  
;     %.   .
;
Signature   EQU	Tpreset+1; 2  -  
; .     A5 E7,     
; ,    
;	
;  
SWAILDR   EQU	Signature+2
SWELEDR   EQU	Signature+3
SWRUDDR   EQU	Signature+4

SWPRESET  EQU	SWRUDDR+1; 
SWMIX1     EQU	SWPRESET+1
SWMIX2     EQU	SWMIX1+1
SWMIX3     EQU	SWMIX2+1
;
SWATRIM   EQU	SWMIX3+D'1'
;
SWALT       EQU	SWATRIM+D'1'
SWSNAPR   EQU	SWALT+D'1'
SWSNAPL   EQU	SWSNAPR+D'1'
;
;      

DWNSecs	  EQU  SWSNAPL+1
DWNMins	  EQU  DWNSecs+1
;
;    
;
Table1	EQU	DWNMins+1  ; 11 
Table2	EQU	Table1+	D'11'; 11 
Table3	EQU	Table2+	D'11'; 11 
Table4	EQU	Table3+	D'11'; 11 !!!
AutoTrimStep EQU Table4+D'11';  AutoTrim? ???
AutoTrimTime EQU AutoTrimStep+1;  ????
;     
; ""  . 
;     . 
; !!!!    !!!!!!!!
ExtTrimZero1 EQU	 AutoTrimTime+1
ExtTrimZero2 EQU	 ExtTrimZero1+1
ExtTrimZero3 EQU	 ExtTrimZero2+1
ExtTrimZero4 EQU	 ExtTrimZero3+1
TrimDIFF        EQU	 ExtTrimZero4+1
TrimFLAP       EQU	 TrimDIFF+1  
TrimSNAPAil       EQU	TrimFLAP+1  
TrimSNAPEle      EQU	TrimSNAPAil+1
TrimSNAPRud     EQU	TrimSNAPEle+1
TrimSNAPTht      EQU	TrimSNAPRud+1
TrimSNAPTpreset     EQU	TrimSNAPTht+1  
TrimCH1         EQU	TrimSNAPTpreset+1  
TrimCH7         EQU	TrimCH1+1
CNTmode	  EQU  TrimCH7+1; 0 = . , 1 =    
SWCH8A	  EQU  CNTmode+1
SWCH8B	  EQU  SWCH8A+1
SWCH8C	  EQU  SWCH8B+1
;
;
; 
;****    ***********
;***************************************************
; Display Line numbers
LINE1      EQU   80;    =00H +80H
LINE2      EQU   94;    =14H + 80H
LINE3      EQU   0C0;    =40H + 80H
LINE4      EQU   0D4;    =54H +80H

CURSORON   EQU   B'00001110'
CURSOROFF  EQU   B'00001100'
YPOS                EQU       08
YNPOS              EQU       0C
NPOS                EQU       0F
ACFTPOS          EQU       0D
BYTEPOS          EQU       0D
PERCENTPOS    EQU       0B
uSPOS              EQU       09
SELCHPOS        EQU       0C
CVMPOS            EQU       0B
ONTIMEPOS      EQU       0B
TESTCHPOS      EQU       07
TESTVALPOS    EQU       0C
TACHRPMPOS   EQU       0B
SELEXTRIMPOS EQU       09
;
;*******    MACROS 
;
;
MOVE		MACRO	REG1,REG2
		MOVFF	REG1,REG2
		MOVFF	REG1+1,REG2+1
		ENDM
;		
MOVEC		MACRO	CONST,REG
		MOVLW	LOW CONST
		MOVWF	REG
		MOVLW	HIGH CONST
		MOVWF	REG+1
		ENDM
;
PUSH_PUSH   MACRO   ;   
            MOVFF   WREG,TEMP_W
	      MOVFF   STATUS,TEMP_STATUS
	      MOVFF   BSR,TEMP_BSR
            MOVFF   PCLATH,TEMP_PCLATH
            MOVFF   PCLATU,TEMP_PCLATU
         ENDM
;
POP_POP    MACRO   ;   
            MOVFF   TEMP_PCLATU,PCLATU
            MOVFF   TEMP_PCLATH,PCLATH
	      MOVFF   TEMP_BSR,BSR
	      MOVFF   TEMP_STATUS,STATUS
            MOVFF   TEMP_W,WREG
         ENDM
;
;     ,
;    
State	MACRO	PORT,BIT
	BCF	STATUS,C
	BTFSC	PORT,BIT
	BSF	STATUS,C
	ENDM
;
;   ,    
;     10 
; (BIT=0,=0 -  )
Pressed	MACRO	PORT,BIT
	State	PORT,BIT
	BTFSC	STATUS,C
	GOTO	$ + D'14'; BIT=1,=1    State
	MOVLW	D'10'
      CALL	Delay1mS

;   10    
	State	PORT,BIT
	ENDM
;
;   (=0),    
;   !!!   (=0),
;  10   .
;   ,  =1  
;
Release		MACRO	PORT,BIT
	State	PORT,BIT
	BTFSS	STATUS,C
	GOTO	$ - 8; BIT=0,=0,   
	;  State     
	MOVLW	D'10'
	CALL	Delay1mS

	State	PORT,BIT
	BTFSS	STATUS,C
	GOTO	$ - D'24';      
; 10 .    BTFSC     State 
;     
	ENDM
;
PrintMess   	MACRO   MESSAGE
	MOVLW	UPPER (MESSAGE)
	MOVWF	TBLPTRU
	MOVLW	HIGH (MESSAGE)
	MOVWF	TBLPTRH
	MOVLW	LOW (MESSAGE)
	MOVWF	TBLPTRL
	CALL	LCDsendMess
    	ENDM
;
     org 0
Reset1:

              GOTO start


;*******   *******
              ORG  0x008
     NOP;  
     NOP;  
	PUSH_PUSH ;  
; Test if this is a CCP1 interrupt
	BTFSC	PIR1,CCP1IF
	CALL	TIMER1ISR
	POP_POP ;  
        RETFIE;     
	

start:


    clrf TMR0L
    clrf TMR0H
    clrf T1CON      ;. TMR1
    clrf T2CON      ;. TMR2
    clrf CCP1CON    ;. CCP1
    clrf CCP2CON    ;. CCP2
    clrf SSPCON1    ;. MSSP
    clrf ADCON0     ;.  
    clrf TMR1L      
    clrf TMR1H

     clrf PORTA ;  PORTA c   
    movlw  B'00001011'; R0,R1,R3- ,  -
    movwf  TRISA
    movlw B'10000100';    R0,R1,R3 , 
    movwf  ADCON1     ;V+ =VDD, V- =VSS

    clrf PORTB ;  PORTB        
    movlw B'11000011';  PORTB   RB2,RB3,RB4,RB5
;    RB2,RB4,RB5 -   
    movwf TRISB
    bsf  PORTB,3;   

    clrf PORTC ;  PORTC    
    movlw B'00000000';  PORTC ,
;  RC1- 1    
    movwf TRISC

    clrf PORTD ;  PORTD    
    movlw B'00000000';  PORTD ,
    movwf TRISD

    clrf PORTE ;  PORTE    
    movlw B'00000000';  PORTE ,
    movwf TRISE

    BSF  ADCON0 , 7  ;    F/32
    BSF  ADCON0 , 0  ; 
 
;********************************
;******   ******
;********************************
	;   
	BCF	PORTC,BUZZER
      BCF	LATC,BUZZER
        CLRF   BeepTicks
        CLRF   BeepCtr
        CLRF   Cmode
;   
        SETF  SelFreq
; 100 mS       
	MOVLW	D'100'
	CALL Delay1mS
	BCF	PORTC,BUZZER
      BCF	LATC,BUZZER


;   PORTB0,PORTB1
	CALL    ReferendumPORTB

	MOVF       PORTB0,W
	MOVWF	    PORTBimage0
	MOVWF	    PORTBlast0   
	MOVWF	    PORTBlatch0
	MOVF       PORTB1,W
	MOVWF	    PORTBimage1
	MOVWF  	PORTBlast1   
	MOVWF	    PORTBlatch1

        CLRF    TimeOut
        CLRF    TimeOut1
        CLRF    TimeOut2
        CLRF    TimeOut3
        CLRF    TimeOut4
        CLRF    TimeOut5
;   
        CLRF   AARGB0
        CLRF   AARGB1
        CLRF   AARGB2
        CLRF   AARGB3
        CLRF   BARGB0
        CLRF   BARGB1
;    
;     :
;  AUTOT   =  0000 0001( )
; .   AUTOT 
;    1000 0001.
;  PRESET  =  0000 0011( )
; .   PRESET 
;    1000 0011.
;       CAL !!!!!
;       
; DFTaircraft     DB
;  !!!   
;       !!!!
	CALL	LoadDefaults
; : DefaultAircraft = Aircraft
	MOVFF	Aircraft,DefaultAircraft
;    
	CALL	LCDinit
	MOVLW	D'250'
	CALL Delay1mS
	MOVLW	D'250'
	CALL Delay1mS
	MOVLW	D'250'
	CALL Delay1mS
	MOVLW	D'250'
	CALL Delay1mS 
;   TMR1
	CALL  Timer1Init

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;   
	BSF     INTCON,GIE
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      CLRF   SpromNo;     
     ;       
      NOP;  

;   OPTION  PRESET 
;     IO  /
; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;    /  
;    
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		Pressed	PORTB0,OPTION
		BTFSC	STATUS,C
		GOTO	TEST2
      NOP;  
      NOP;  
		Pressed	PORTB0,PRESET
		BTFSS	STATUS,C
		GOTO	TestIO

TEST2
      NOP;  

	Pressed   PORTB0,PRESET
	BTFSC	    STATUS,C
	GOTO	    DATAREAD
	Pressed PORTB0,AUTOT
	BTFSS	    STATUS,C
	GOTO	    UseDefaults
DATAREAD	
	CALL	    SpromInit
;      # 1
	MOVLW     01
	MOVWF    Breg
	CALL	    SpromRead
;  .    -
;    
	MOVE        Signature,AXreg 
	MOVLW	      0A5
	CPFSEQ	AXreg
	GOTO	      FormatIt
	MOVLW	      0E7
	CPFSEQ	AXreg+1
	GOTO	      FormatIt
	GOTO	      LoadDefAircraft
;   
FormatIt
	CALL	FormatSprom
	MOVLW     01
	MOVWF    Breg
	CALL	    SpromRead
    NOP;  
;     ,
;    .
;     -
;    
	MOVE   Signature,AXreg 
	MOVLW	      0A5
	CPFSEQ	AXreg
	GOTO	      UseDefaults
	MOVLW	      0E7
	CPFSEQ	AXreg+1
	GOTO	      UseDefaults
LoadDefAircraft
;     
	MOVFF       DefaultAircraft,Breg
	CALL	      SpromRead
      CLRF   SpromNo;    
	GOTO	      UseDefaults1
UseDefaults
      SETF   SpromNo 
;     ,
; ..  . .   
	CALL	LoadDefaults
; : DefaultAircraft = Aircraft
	MOVFF	Aircraft,DefaultAircraft

      NOP;  

UseDefaults1
	
; ,    AUTOTRIM 
;     

	Pressed PORTB0,AUTOT
	BTFSS	    STATUS,C
	GOTO	   UseDefaults1

      GOTO   $;  !!!!

;
;  /    ,   
;   PORTB   4  5

ReferendumPORTB
        SETF    PORTB0
        SETF    PORTB1

	BCF     PORTB,2
	BCF     PORTB,4
	BCF     PORTB,5

      MOVLW   01
      CALL      Delay100uS

	BTFSS   PORTB,0
	BCF     PORTB0,0
	BTFSS   PORTB,1
	BCF     PORTB1,0

	BSF     PORTB,2

      MOVLW   01
      CALL      Delay100uS

	BTFSS   PORTB,0
	BCF     PORTB0,1
	BTFSS   PORTB,1
	BCF     PORTB1,1

	BCF     PORTB,2
	BSF     PORTB,4

      MOVLW   01
      CALL      Delay100uS

	BTFSS   PORTB,0
	BCF     PORTB0,2
	BTFSS   PORTB,1
	BCF     PORTB1,2

	BSF     PORTB,2

      MOVLW   01
      CALL      Delay100uS

	BTFSS   PORTB,0
	BCF     PORTB0,3
	BTFSS   PORTB,1
	BCF     PORTB1,3

	BCF     PORTB,2
	BCF     PORTB,4
	BSF     PORTB,5

      MOVLW   01
      CALL     Delay100uS

	BTFSS   PORTB,0
	BCF     PORTB0,4
	BTFSS   PORTB,1
	BCF     PORTB1,4

	BSF     PORTB,2

      MOVLW   01
      CALL     Delay100uS

	BTFSS   PORTB,0
	BCF     PORTB0,5
	BTFSS   PORTB,1
	BCF     PORTB1,5

	BCF     PORTB,2
	BSF     PORTB,4

      MOVLW   01
      CALL      Delay100uS

	BTFSS   PORTB,0
	BCF     PORTB0,6
	BTFSS   PORTB,1
	BCF     PORTB1,6

	BSF     PORTB,2

      MOVLW   01
      CALL      Delay100uS

	BTFSS   PORTB,0
	BCF     PORTB0,7
	BTFSS   PORTB,1
	BCF     PORTB1,7
	RETURN
;
;
;
;  - IO   ,   OPTION   PRESET
;    .
;       (  )
; PORTB0   ,  PORTB1   .
; !!!    /    !!!!
TestIO
  ;          CALL     ReferendumPORTB
           MOVLW   0FF
           MOVWF   Mode;   RUN     

            BTFSS   PORTB0,OPTION   
            GOTO    TestIO
            BTFSS	PORTB0,PRESET   
            GOTO    TestIO

TestIOa
;      
;        
		MOVLW	  LINE1
		CALL      LCDsendCMD
		PrintMess MES0
		MOVLW	  LINE2
		CALL      LCDsendCMD
		PrintMess MES0
		MOVLW	LINE3
		CALL    LCDsendCMD
		PrintMess MES1
		MOVLW	LINE4
		CALL    LCDsendCMD
		PrintMess MES2
TestIOa1
	;     IO 
;            CALL     ReferendumPORTB
		MOVLW	  LINE1
		CALL    LCDsendCMD	;   
		PrintMess MES23
		MOVLW	  LINE1+8
		CALL    LCDsendCMD	;   
		MOVF	PORTB0,W
		CALL	LCDbinary

		MOVLW	  LINE2
		CALL    LCDsendCMD   ;   
		PrintMess MES24
		MOVLW	  LINE2+8
		CALL    LCDsendCMD	;   
		MOVF	PORTB1,W
		CALL	LCDbinary

	;  
	        BSF       PORTC,LED1; . 

	        BTFSS   PORTB0,PRESET
	        BCF       PORTC,LED1; . 
                            ;   PRESET

	;  
	        BCF       PORTC,BUZZER; . 
	        BTFSS   PORTB0,AUTOT
	        BSF       PORTC,BUZZER; .  
                            ;   AUTOTRIM
	;      OPTION
		MOVLW 	D'50'
		CALL	     Delay1mS
		Pressed	PORTB0,OPTION
		BTFSC	     STATUS,C
		GOTO	     TestIOa1

TestIO2
 ;           CALL     ReferendumPORTB
		Pressed	PORTB0,OPTION
		BTFSS	     STATUS,C
		GOTO	     TestIO2

	;      

;      
		MOVLW	      LINE1
		CALL           LCDsendCMD
		PrintMess   MES0
		MOVLW	      LINE2
		CALL           LCDsendCMD
		PrintMess   MES0

		CLRF     	AXreg;   
TestIO1
            MOVFF       AXreg,PORTE;   
		MOVLW	      LINE1
		CALL           LCDsendCMD
		PrintMess    MES3
		MOVLW	       LINE1+TESTCHPOS
		CALL           LCDsendCMD

		MOVFF	        AXreg,DXreg
		CLRF            DXreg+1 
		CALL	        Conversion
;      ASCII    
		MOVLW   H'30'
		ADDWF   EXreg,F
		ADDWF   EXreg+1,F
		MOVF	  EXreg+1,W
		CALL      LCDsendData
		MOVF	  EXreg,W
		CALL 	  LCDsendData
		MOVF	  AXreg,W

		CALL	  OverSample

		MOVLW	    LINE1+TESTVALPOS
		CALL        LCDsendCMD
		MOVFF	   Pos+1,DXreg+1
		MOVFF	   Pos,DXreg
		CALL	   Conversion
;      ASCII    
		MOVLW     H'30'
		ADDWF     EXreg,F
		ADDWF     EXreg+1,F
		ADDWF     EXreg+2,F
		ADDWF     EXreg+3,F
		MOVF        EXreg+3,W
		CALL	     LCDsendData
		MOVF	     EXreg+2,W
		CALL	     LCDsendData
		MOVF	     EXreg+1,W
		CALL	     LCDsendData	
		MOVF	     EXreg,W
		CALL	     LCDsendData
	; 
		MOVLW	     D'50'
		CALL	     Delay1mS
	;   OPTION    
	;   .   17 - 
   ;         CALL     ReferendumPORTB
		Pressed	PORTB0,OPTION
		BTFSC	      STATUS,C
		GOTO	      TestIO1
;		Release	PORTB0,OPTION
TestIO3
  ;          CALL     ReferendumPORTB
		Pressed	PORTB0,OPTION
		BTFSS	     STATUS,C
		GOTO	     TestIO3
	;   
		INCF	      AXreg
		MOVLW	      D'16'
		CPFSGT	AXreg
		GOTO	      TestIO1
		GOTO	      TestIO
;
;
;
LCDbinary
;  W     
		MOVWF	     Areg
		MOVLW	     D'8'
		MOVWF	     Breg
LCDbinary0
		MOVLW	     30;  0,   
		BTFSC	     Areg,7
		MOVLW	     31;  1,   
		CALL	     LCDsendData
		RLCF	     Areg
		DECFSZ     Breg
		GOTO	     LCDbinary0
		RETURN
;
;
;
Conversion 
; <DXreg+1;DXreg>  - 
; EXreg   -  
; EXreg+1 -  
; EXreg+2 -  
; EXreg+3 -  
	CLRF	EXreg
	CLRF	EXreg+1
	CLRF	EXreg+2
	CLRF	EXreg+3
start_conversion
 ;  (EXreg+3,EXreg+2;EXreg+1;EXreg)
;     10  (DXreg+1;DXreg)
;    700   
    movlw    D'10'
    subwf     DXreg,F
    movlw    D'0'
    subwfb   DXreg+1,W; W=(DXreg+1)-0-(-C)
    btfsc      STATUS,C
    goto       restore_conversion
    movlw    D'10'; (DXreg+1;DXreg) <10
    addwf     DXreg,F
    movff     DXreg,EXreg; EXreg=DXreg-   
    goto       end_conversion
restore_conversion ;(DXreg+1;DXreg) >=10
    movwf    DXreg+1
    incf         EXreg+1,F
    movlw     D'10'
    cpfseq    EXreg+1
    goto   start_conversion
    clrf          EXreg+1
    incf         EXreg+2,F
    movlw    D'10'
    cpfseq    EXreg+2
    goto   start_conversion
    clrf         EXreg+2
    incf        EXreg+3,F
    goto   start_conversion
end_conversion
	RETURN
;
;

;
;
;   Timer1.
Timer1Init
;      

 	MOVLW    TICKSPER	;    
	MOVWF     Tick	; 
	CLRF   	    Mins
	CLRF	    Secs
	MOVLW     2
	MOVWF	    Pstate
;      
;    1024  = D'2048'(= H'0800') T
	CLRF	CHtimes
	CLRF	CHtimes+2
	CLRF	CHtimes+4
	CLRF	CHtimes+6
	CLRF	CHtimes+8
	CLRF	CHtimes+D'10'
	CLRF	CHtimes+D'12' 
	CLRF	CHtimes+D'14'
	CLRF	CHtimes+D'16'

	MOVLW	    8
	MOVWF	    CHtimes+1
	MOVWF	    CHtimes+3
	MOVWF    CHtimes+5
	MOVWF    CHtimes+7
	MOVWF	    CHtimes+9
	MOVWF	    CHtimes+D'11'
	MOVWF    CHtimes+D'13'
	MOVWF    CHtimes+D'15'
	MOVWF	    CHtimes+D'17'
	MOVLW     LOW D'400'
	MOVWF	    Sync
	MOVLW    HIGH D'400'
	MOVWF	   Sync+1
;   Psum = CHtimes
	MOVE      CHtimes,Psum
;   NextTime = CHtimes - Sync = Psum - Sync !!!  !!!
	MOVE      Psum,NextTime
	MOVF	  Sync ,W
	SUBWF	  NextTime,F
	MOVF	  Sync+1 ,W
      BTFSS    STATUS,C
      INCF      Sync+1,W
	SUBWF	  NextTime+1,F
 ;     CCPR1  CCPR2  
	MOVF	   Sync,W
	MOVWF	   CCPR1L
	MOVWF   CCPR2L
	MOVF	   Sync+1,W
	MOVWF	   CCPR1H
	MOVWF	   CCPR2H

;  CCP1 - .  . 
        MOVLW   B'00001011'
        MOVWF   CCP1CON	
;  CCP2 - .   RC1  
        MOVLW   B'00001001'
        MOVWF   CCP2CON	

	BSF PORTC,1 ;     RC1

	;   
	BCF	PIR1,CCP1IF
	BCF	PIR2,CCP2IF
	;    1
	BSF	PIE1,CCP1IE
	;     
	BSF     INTCON,PEIE

	;  
	BSF	T1CON,TMR1ON; . TMR1
	RETURN
;
; 
;    Timer1 
;  /   PPM .  Pstate
;  .  Pstate   -
;    .
;
TIMER1ISR
      MOVLB   00;  0.    - 
            ;        

      CLRF  TMR1H;    MPLAB SIM   !

	BCF	PIE1,CCP1IE;    1
   
	;      
 	MOVLW	  0FF;  
	MOVWF	   CCPR1H
 	MOVWF	   CCPR2H

 	MOVF	   NextTime +1,W
	MOVWF	   CCPR1H
 	MOVWF	   CCPR2H
 	MOVF	   NextTime,W 
	MOVWF	   CCPR1L
 	MOVWF	   CCPR2L

	INCF	   Pstate,F

;   Pstate=18
	MOVF	  Pstate,W
	SUBLW	  D'18'
      BTFSS    STATUS,Z		
	GOTO	  TIMER1ISR0
	;   Pstate=18
	;    
	;    40Hz
	MOVLW	   LOW CYCLECOUNTS
	MOVWF	   NextTime
	MOVF	   Psum,W
	SUBWF	   NextTime,F
	MOVLW	   HIGH CYCLECOUNTS
	MOVWF	   NextTime+1
	MOVF	   Psum+1,W
        BTFSS    STATUS,C
        INCF      Psum+1,W
	SUBWF	    NextTime+1,F
	CLRF	    Psum
	CLRF	    Psum+1
	CLRF	    Pstate
;  CCP2 - .   RC1  
        MOVLW   B'00001001'
        MOVWF   CCP2CON

	GOTO	TIMER1ISR3
TIMER1ISR0
	;     Pstate.   Pstate 
	;  - TMR1     
;    Pstate  - TMR1  
;    ( . .   Pstate=1)
	BTFSS	    Pstate,0
	GOTO	    TIMER1ISR1
	MOVF	    Sync ,W
	MOVWF	    NextTime
	MOVF	    Sync+1,W
	MOVWF	    NextTime+1
;  CCP2 - .   RC1  
        MOVLW   B'00001000'
        MOVWF   CCP2CON

        MOVLW   01
        CPFSGT  Pstate
	CALL	RTC;                          
       ;   40      Pstate=1
        GOTO      TIMER1ISR2

;       
TIMER1ISR1
	LFSR	   FSR0,CHtimes
	MOVF	   Pstate ,W
	ADDWF	   FSR0L
	MOVF	   INDF0,W
	MOVWF   NextTime
	INCF	   FSR0L
	MOVF	   INDF0,W
	MOVWF	   NextTime+1

;      
	MOVF	   Sync ,W
	SUBWF	   NextTime,F
	MOVF	   Sync+1 ,W
        BTFSS   STATUS,C
        INCF     Sync+1,W
	SUBWF	   NextTime+1,F
;  CCP2 - .   RC1  
        MOVLW   B'00001001'
        MOVWF   CCP2CON
	;    
TIMER1ISR2
	MOVF	    NextTime ,W
	ADDWF	    Psum,F
	MOVF	    NextTime+1 ,W
        BTFSC    STATUS,C
        INCF      NextTime+1,W
	ADDWF	    Psum+1,F

	;     
TIMER1ISR3
	BCF	PIR1,CCP1IF
	BCF	PIR2,CCP2IF

	BSF	PIE1,CCP1IE;    1

	RETURN
;
;
Delay2uS    ;    2*WREG  
		NOP
		DECFSZ	WREG
		GOTO	      Delay2uS
		RETURN
;
;
Delay1mS    ;    1*W
		MOVWF	   TimeCount1
Delay1mS0
		MOVLW	   D'250'
;		MOVWF   TimeCount
		CALL	   Delay2uS
		MOVLW	   D'250'
;		MOVWF   TimeCount
		CALL	   Delay2uS
		DECFSZ  TimeCount1,F
		GOTO	   Delay1mS0
		RETURN
;
;
;
;
Delay100uS    ;    150*W
		MOVWF	      TimeCount100
Delay100
		MOVLW	      D'75'
		CALL	      Delay2uS
		DECFSZ	TimeCount100,F
		GOTO	      Delay100
		RETURN
;
;
;


;  /   25   Pstate=0. 
;     .
;  10    o   .
RTC
;  OVERRUN      RUN
		MOVF	Mode,F
		BTFSS  STATUS , Z		
		GOTO	NotOverrunTest
;  
		BSF	PORTC,LED1
; .    OVERRUN -  
		BTFSS	OVERRUN,0
		GOTO    OFF_LED1
		BCF	PORTC,LED1;  
OFF_LED1	 
	;    OVERRUN 
		MOVLW	0FF
		MOVWF	OVERRUN
NotOverrunTest
		DECFSZ	Tick,F
		GOTO	      RTC1
	;    
;    
;       
;  Cmode=0 -  : Cmode=1 -  
		BTFSS	  Cmode,0
		GOTO	  RTC1a
		MOVF 	  Dsecs,W
		IORWF	  Dmins,W
		BTFSC	  STATUS , Z
		GOTO	  RTC1a; Dmins=Dsecs=0 -   
	;   ...
		MOVF	  Dsecs,F
		BTFSS	  STATUS , Z
		GOTO	  RTC1b
	;   Sec =0
;    -  Dsec=60 
		MOVLW	  D'60'
		MOVWF  	Dsecs
		DECF	  Dmins,F
RTC1b
		DECF	  Dsecs,F
RTC1c
		MOVF      Dsecs,W
		MOVWF	   DsecsLatch
RTC1a;   
;        
;     OPTION
		MOVLW	   TICKSPER
		MOVWF	   Tick
		INCF	   Secs,F
		MOVLW	   D'60'
		CPFSEQ   Secs
		GOTO	   RTC1
;      
;  0  99
		CLRF	Secs
		INCF	Mins , F
RTC1
	;   PORTB0  PORTB1
	CALL    ReferendumPORTB
;  PORTB0
		MOVF   	   PORTB0,W
		XORWF	   PORTBlast0,F
		BTFSS	   STATUS,Z
		MOVWF	    PORTBimage0
		MOVWF	    PORTBlast0
		MOVF	    PORTBimage0,W
		IORWF	    PORTBlatch0,F
;  PORTB1
		MOVF   	     PORTB1,W
		XORWF	     PORTBlast1,F
		BTFSS	     STATUS,Z
		MOVWF	     PORTBimage1
		MOVWF	     PORTBlast1
		MOVF	     PORTBimage1,W
		IORWF	     PORTBlatch1,F

	;   TimeOut 
		TSTFSZ	TimeOut 
		DECF	TimeOut ,F
		TSTFSZ	TimeOut1 
		DECF	TimeOut1 ,F
		TSTFSZ	TimeOut2  
		DECF	TimeOut2 ,F
		TSTFSZ	TimeOut3 
		DECF	  TimeOut3 ,F
		TSTFSZ	TimeOut4 
		DECF	      TimeOut4 ,F
		TSTFSZ	TimeOut5 
		DECF	      TimeOut5 ,F
	;    
		TSTFSZ	BeepCtr
		GOTO	       RTC2
		RETURN  ; BeepCtr=0 -   
RTC2	;    
		DECFSZ	BeepCtr
		RETURN
	      BTG	      PORTC,BUZZER;                             
		DCFSNZ	BeepCyl
		RETURN;   BeepCyl=0 -   
;   BeepCtr
		MOVF	     BeepTicks,W ; 
		MOVWF	     BeepCtr

		RETURN
;
;
;    /  W   
;  ( 25  ). 
;   = W * 25  
; BeepCly       .
;     .
Beep

		MOVWF	  BeepTicks
		MOVWF	  BeepCtr
	; !
		BSF	PORTC,BUZZER
		RETURN

;
;
LoadDefaults
;  /    DFTaircraft   1 
; Areg =     0  255
    CLRF  Areg; 
;     RAM
; (H'100' -   1)
        LFSR     FSR1,Aircraft
;    DFTaircraft
	MOVLW	   HIGH (DFTaircraft)
	MOVWF	   TBLPTRH
	MOVLW	   LOW (DFTaircraft)
	MOVWF	  TBLPTRL 
LDef01
;   TABLAT    
     TBLRD*+
;    
;      
     MOVFF    TABLAT,POSTINC1
     INCFSZ   Areg,F; Areg=00=256?
     GOTO      LDef01; , 
	RETURN
;
;
CalSprom
	RETURN
;
;
;
;
;  /   ADC ,    W.
;     ADC  return.
;      Pos.
;    / Areg   .
;  1-8   AN0
; T  1-4  EXTRIM1,EXTRIM2,EXTRIM3,EXTRIM4
;   AN1
;  V   AN3
ADCread
		MOVWF 	Areg	;   

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;       
;     ,   W 
; 00-CH8 ; 01-CH5 ; 02-CH7 ; 03-CH6 ; 04- ; 
; 05-  ; 06-  ; 07- ;  
; 08-  ; 09-   ; 
; 10-   ; 11-  ; 12-EXTRIM4 ;
; 13-EXTRIM1 ; 14-EXTRIM2 ; 15-EXTRIM3 ;
; 16-V ; 17-EXTRIM5 ; 18-EXTRIM6 ;
; 19-EXTRIM7 ; 20-EXTRIM8 ; 21-EXTRIM9 ;
; 22-EXTRIM10 ; 23-EXTRIM11 
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!						
;
	   BTFSS Areg,4
	   GOTO  ADCread4
           GOTO  ADCread3; V, EXTRIM5-EXTRIM11
ADCread4
	   BTFSS Areg,3
	   GOTO  ADCread0; CH1-CH8
           GOTO  ADCread1;   1-4,
                         ;  EXTRIM1-EXTRIM4
ADCread0
;   AN0(RA0)  
  		MOVLW  B'10000001'
		MOVWF	ADCON0
		GOTO  ADCDelay

ADCread1
;   AN1(RA1)  
  		MOVLW  B'10001001'
		MOVWF	ADCON0
		GOTO  ADCDelay
ADCread3
;   AN3(RA3)  
  		MOVLW  B'10011001'
		MOVWF	ADCON0

ADCDelay	; 20    
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
;        
		BSF	   ADCON0,GO
	;   
ADCread2
		BTFSC	   ADCON0,GO
		GOTO	   ADCread2
	;    Pos
		MOVF	   ADRESL,W
		MOVWF	   Pos
		MOVF	   ADRESH,W
		MOVWF	   Pos+1

		RETURN
;
;
;           
;    Pos.     .
ADCreadAgainandSum

		BSF	   ADCON0,GO
	; Wait for the ADC to finish
ADCreadAgain0
		BTFSC	   ADCON0,DONE
		GOTO	   ADCreadAgain0
	; Now sum with Pos

		MOVF	   ADRESL,W
		ADDWF	   Pos,F
		MOVF	   ADRESH,W
		ADDWFC	Pos+1,F
		RETURN
;
;
;
;    / WREG   .
OverSample
	;  ADC  4     
		CALL	ADCread
            NOP
            NOP
            NOP
            NOP
		CALL	ADCreadAgainandSum
            NOP
            NOP
            NOP
            NOP
		CALL	ADCreadAgainandSum
            NOP
            NOP
            NOP
            NOP
		CALL	ADCreadAgainandSum
	;    4

		;   2
		RRCF	Pos+1
		BCF	Pos+1,7
		RRCF	Pos

		;   2
		RRCF	Pos+1
		BCF	Pos+1,7
		RRCF	Pos

		BCF	Pos,0;   

		RETURN;
;
;
;
;
;
;***************************************
; LCD 
;
DISP_ON	   EQU	0x00C;  
DISP_ON_C  EQU	0x00E;  ,
		     ; 
DISP_ON_B  EQU	0x00F;  ,
		     ;  ,
		     ;  
DISP_OFF   EQU	0x008;  
CLR_DISP   EQU	0x001;  
;
;      LCD
E	EQU     2; Enable
RW      EQU	4; Read/Write
RS      EQU	5; Register Select
LCDCTRL  EQU	PORTA
;   LCD   PORTD<7:0>
;
LCD_DATA   EQU    PORTD; LCD  - 8
;***************************************
;***************************************
;  LCD 
;***************************************
LCDinit
        BCF     LCDCTRL, RW 
        BCF     LCDCTRL, RS 
        BCF     LCDCTRL, E

        MOVLW   B'00110000'
        MOVWF   LCD_DATA 
        BSF     LCDCTRL, E 
        NOP
        NOP
        BCF     LCDCTRL, E

	  MOVLW 05
	  CALL	Delay1mS

        BSF     LCDCTRL, E 
        NOP
        NOP
        BCF     LCDCTRL, E

	  MOVLW D'80'
	  CALL	Delay2uS


        BSF     LCDCTRL, E 
        NOP
        NOP
        BCF     LCDCTRL, E 
 


    MOVLW   B'00111000';  8- ,
;    ,  58 

    MOVWF   LCD_DATA 
    NOP
    NOP 
    BSF     LCDCTRL, E
    NOP
    NOP
    NOP
    NOP 
    BCF     LCDCTRL, E

	MOVLW 05
	CALL	Delay1mS

        MOVLW   B'00001000';  ,
;  
        MOVWF   LCD_DATA 
        BSF     LCDCTRL, E 
        NOP
        NOP
    NOP
    NOP
        BCF     LCDCTRL, E

	MOVLW 01
	CALL	Delay1mS

        MOVLW   B'00000001';  
        MOVWF   LCD_DATA 
        BSF     LCDCTRL, E
        NOP
        NOP 
    NOP
    NOP
        BCF     LCDCTRL, E

	MOVLW 03
	CALL	Delay1mS

        MOVLW   B'00000110';   00,
;     
        MOVWF   LCD_DATA 
        BSF     LCDCTRL, E
        NOP
        NOP
    NOP
    NOP 
        BCF     LCDCTRL, E

	MOVLW 1
	CALL	Delay1mS

        MOVLW   B'00001110';  ,
;   
        MOVWF   LCD_DATA 
        BSF     LCDCTRL, E 
        NOP
        NOP
    NOP
    NOP
        BCF     LCDCTRL, E

;      
	MOVLW	      LINE1
	CALL 	      LCDsendCMD
	MOVLW 	HIGH (MES1)
	MOVWF 	TBLPTRH
	MOVLW	      LOW (MES1)
	MOVWF	     TBLPTRL
	CALL	     LCDsendMess
	MOVLW	     LINE2
	CALL	     LCDsendCMD
	MOVLW	     HIGH (MES2)
	MOVWF	    TBLPTRH
	MOVLW	    LOW (MES2)
	MOVWF	    TBLPTRL
	CALL	    LCDsendMess
	RETURN
;
;****************************************
;*    LCDsendData -    LCD          *
;****************************************
;
LCDsendData
        MOVWF   DataTemp ;   W
        CALL    BUSY_CHECK  
        MOVF    DataTemp, W
        MOVWF   LCD_DATA 
        BCF     LCDCTRL, RW ;  LCD 
        BSF     LCDCTRL, RS ;    RAM
        NOP
        NOP
        BSF     LCDCTRL, E;    LCD
        NOP
        NOP 
    NOP
    NOP  
        BCF     LCDCTRL, E
        BCF     LCDCTRL, RS        
        RETURN
;
;*****************************************
;*     /     LCD             * 
;*****************************************
;
LCDsendCMD
        MOVWF   DataTemp;   W
;	BTFSS	DataTemp,7;   DDRAM 0F ???
;	GOTO	LCDnoBitClear
;	BCF	DataTemp,6
;	BCF	DataTemp,5	
;	BCF	DataTemp,4
;LCDnoBitClear	
        CALL    BUSY_CHECK        
        MOVF   DataTemp, W
        MOVWF   LCD_DATA ;    LCD
        BCF     LCDCTRL, RW  ;  LCD  
        BCF     LCDCTRL, RS  ;  
        BSF     LCDCTRL, E
        NOP
        NOP 
    NOP
    NOP
        BCF     LCDCTRL, E
        RETURN
;
;**********************************************
;*  /   BF  LCD.              *
;*    BF                           *
;*  TEMP -                  *
;**********************************************
BUSY_CHECK
        CLRF       LCD_DATA
        MOVLW   0xFF ; PORTD -
        MOVWF   TRISD
        BCF         LCDCTRL, RS ;   
        BSF         LCDCTRL, RW;   BF
        NOP
        NOP   
        BSF         LCDCTRL, E 
        NOP
        NOP        
        MOVF       LCD_DATA, W   
        MOVWF    DataCheck
        BCF          LCDCTRL, E  
        BTFSC      DataCheck, 7 ;  BF  ? 
        GOTO       BUSY_CHECK;   
        BCF          LCDCTRL, RW;   RW
	  NOP
	  NOP
        MOVLW     0x00                ;
        MOVWF    TRISD; PORTD -
        RETURN
;
LCDsendAX;     1
		MOVLW	   LINE1
		CALL	   LCDsendCMD
		MOVFF	   AXreg,TBLPTRL
		MOVFF	   AXreg+1,TBLPTRH
		CALL       LCDsendMess
		RETURN
;
LCDsendAXLine2;     2
		MOVLW	   LINE2
		CALL	   LCDsendCMD
		MOVFF	   AXreg,TBLPTRL
		MOVFF	   AXreg+1,TBLPTRH
		CALL       LCDsendMess
		RETURN
;
Int2Str
		RETURN
;
DisplayAircraftName
;  /    16 
;       .
;     D'1'
;    Name - H'0101'
;     D'16'
	MOVLW	   LINE2
	CALL	   LCDsendCMD
	LFSR	   FSR1,Name
Next_Char
	MOVF	   INDF1,W
	CALL	   LCDsendData
	INCF       FSR1L,F
	MOVLW	   D'17';    -1 
	CPFSEQ   FSR1L  
	GOTO	   Next_Char
	RETURN
; 
;  /    16 
;   .
;        
; TBLPTRH,TBLPTRL
;    1  16
LCDsendMess
;
	MOVLW	      D'16';    
	MOVWF	      Areg
NEXT
;  TABLAT    
	TBLRD*+;  TABLAT
	MOVF	     TABLAT,W
	CALL	      LCDsendData;  
	DECFSZ	Areg
	GOTO	      NEXT
	RETURN
;
;
SpromInit
	RETURN
;
;
SpromRead
	RETURN
;
;
FormatSprom
	RETURN
;
;
;
;
DFTaircraft

;     MODEL 01 -    
  DB 01,04D,04F,044,045,04C,020,030,031,020,020,020,020,020,020,020
  DB 020,00;     REVERS
  DB 00,00,D'100',00,D'100',D'100',00,D'100'; LINLOG   
  DB 00,D'100',00,D'100',D'100',00,D'100',00,D'100',00,D'100',D'100',00,D'100'
;      

;     CH5
  DB 00,D'100',00,D'100',D'100',00,D'100',00,D'100',00,D'100',D'100'
  DB 00,D'100',00,D'100',D'100',00,D'100',00,D'100',D'100';  CH6  CH7
  DB 00,D'100',00,D'100',D'100',00;  CH8  VTAIL
  DB 00,00,00,00,00,01,01,0FF; ELEVON,DUALA,REVA,DIFFA,FPgain,DefaultAircraft,ALTaircraft,FixedFirst

  DB 00,00,00,00,00,00,00,00;  M1A
  DB 00,00,00,00,00,00,00,00;  M1B
  DB 00,00,00,00,00,00,00,00;  M1C

  DB 00,00,00,00,00,00,00,00;  M2A
  DB 00,00,00,00,00,00,00,00;  M2B
  DB 00,00,00,00,00,00,00,00;  M2C

  DB 00,00,00,00,00,00,00,00;  M3A
  DB 00,00,00,00,00,00,00,00;  M3B
  DB 00,00,00,00,00,00,00,00;  M3C

  DB 00,00,00,00,00,00,00,00; TrimZeroAil,TrimZeroEle,TrimZeroRud,TrimZeroTht 
  DB D'100',00,D'100',00,D'100',00,D'100',00;  
  DB D'100',00,D'100',00,D'100',00,D'100',00;  
  DB D'100',0A5,0E7,020,020,020; Tpreset,Signature,SWAILDR,SWELEDR,SWRUDDR
  DB 03,020,020,020,01,020;SWPRESET,SWMIX1,SWMIX2,SWMIX3,SWATRIM,SWALT
  DB 020,020,00,D'1'; SWSNAPR,SWSNAPL,DWNSecs,DWNMins
  DB D'100',D'100',D'100',D'100',D'100',D'100'; Table1 - Table4
  DB D'100',D'100',D'100',D'100',D'100',D'100'
  DB D'100',D'100',D'100',D'100',D'100',D'100'
  DB D'100',D'100',D'100',D'100',D'100',D'100'
  DB D'100',D'100',D'100',D'100',D'100',D'100'
  DB D'100',D'100',D'100',D'100',D'100',D'100'
  DB D'100',D'100',D'100',D'100',D'100',D'100' 
  DB D'100',D'100'
  DB 0DE,030; AutoTrimStep,AutoTrimTime
  DB 00,00,00,00;ExtTrimZero1,ExtTrimZero2,ExtTrimZero3,ExtTrimZero4
  DB 00,00;TrimDIFF,TimFLAP
  DB 00,00,00,00;TrimSNAPAil,TrimSNAPEle,TrimSNAPRud,TrimSNAPTht
  DB 00,00,00,01;TrimSNAPTpreset,TrimCH1,TrimCH7,CNTmode
  DB 020,020,020,00,00,00,00,00; SWCN8A,SWCN8B,SWCN8C
;
;
;
;
;===================================================
;
;      
;
;===================================================
MES0		DB	"                ",0
MES1		DB	" MicroStar 2000 ",0
MES2		DB	" Version 1.0RUS ",0
MES3		DB	"ADC CH XX = XXXX",0
MES4		DB	"   Aircraft #   ",0
MES5		DB	"     53.X MHz   ",0
MES6		DB	"       OFF      ",0
MES7		DB	" Accept? Yes No ",0
MES8		DB	" Press   Option ",0
MES9		DB	"  Save changes  ",0
MES10		DB	"    Student     ",0
MES11		DB	" Yes No ",0
MES12		DB	" Save ?         ",0
MES13		DB	"   Saving....   ",0
MES14		DB	" 50.XX MHz  CHX ",0
MES15		DB	"xBld RPM = xxxxx",0
MES16		DB	"Retracts are UP!",0
MES17		DB	"Format PRI SPROM",0
MES18		DB	"Format SEC SPROM",0
MES19		DB	"  Formating...  ",0
MES20		DB	"   Copying...   ",0
MES21		DB	"EXIT ?          ",0
MES22		DB	"Rec Volts       ",0
MES23		DB	"PORTB0          ",0
MES24		DB	"PORTB1          ",0
;





	end
